//
// FilenameTransformSpec.cpp
//

//
// This software is protected by the GNU General Public License,
// also known as the GPL.
//
// See the file COPYING.txt for details.
//

#include "StdHdr.h"

#include "FilenameTransformSpec.h"

/**************************************************************************

>	void FilenameTransformSpec::SetSourcePattern(const vos::String& RegExp)

	Author:		Tim Browse
	Date:		29/4/2002
	Inputs:		RegExp - regular expression to use.

	Purpose:	Set the regular expression to the string passed in.

**************************************************************************/

void FilenameTransformSpec::SetSourcePattern(const vos::String& RegExp)
{
	try
	{
		m_RegExp.assign(RegExp.c_str());
	}
	catch(...)
	{
		// Ignore problems in regexp
		// TODO: Tell user about it
	}
}


FilenameTransformSpec::FilenameTransformSpec(const FilenameTransformSpec& rhs)
{
	try
	{
		m_RegExp = rhs.m_RegExp;
	}
	catch (...)
	{
	}

	m_fsFolder = rhs.m_fsFolder;
	m_NewNameSpec = rhs.m_NewNameSpec;
}

FilenameTransformSpec& FilenameTransformSpec::operator=(const FilenameTransformSpec& rhs)
{
	// Check for self assignment
	if (&rhs == this)
		return *this;

	try
	{
		m_RegExp = rhs.m_RegExp;
	}
	catch (...)
	{
	}

	m_fsFolder = rhs.m_fsFolder;
	m_NewNameSpec = rhs.m_NewNameSpec;

	return *this;
}
