//
// FilenameTransformSpec.h
//

//
// This software is protected by the GNU General Public License,
// also known as the GPL.
//
// See the file COPYING.txt for details.
//

#ifndef inc_FilenameTransformSpec_h
#define inc_FilenameTransformSpec_h

#include <boost/regex.hpp>

#include "vos\FileSpec.h"
#include "vos\String.h"

/**************************************************************************

>	class FilenameTransformSpec

	Author:		Tim Browse
	Date:		29/4/2002

	Purpose:	Hold information about how to transform a filename

**************************************************************************/

class FilenameTransformSpec
{
	public:
		// Set the regexp pattern to match with (and extract strings with)
		void SetSourcePattern(const vos::String& RegExp);

		FilenameTransformSpec() {}
		FilenameTransformSpec(const FilenameTransformSpec& rhs);
		FilenameTransformSpec& operator=(const FilenameTransformSpec& rhs);
		
	public:
		// The (optional) regular expression to match with, to 
		// extract segments of the filename.
		//
		// TODO: use RegEx class instead
		boost::regex m_RegExp;

		// The folder that contains the file to be renamed
		vos::FileSpec m_fsFolder;

		// The new name pattern to use to construct the new filename
		vos::String m_NewNameSpec;
};

#endif // !inc_FilenameTransformSpec_h

