//
// FilenameValidateWorker.h
//

//
// This software is protected by the GNU General Public License,
// also known as the GPL.
//
// See the file COPYING.txt for details.
//

#ifndef inc_FilenameValidateWorker_h
#define inc_FilenameValidateWorker_h

#include "vgui\JobWorker.h"
#include "vgui\ListBox.h"

class FilenameList;

/**************************************************************************

>	class FilenameValidateWorker : public vgui::JobWorker

	Author:		Tim Browse
	Date:		29/4/2002

	Purpose:	Fill a list view control with previews of new filenames.

**************************************************************************/

class FilenameValidateWorker : public vgui::JobWorker
{
	public:
		// Constructor
		FilenameValidateWorker(FilenameList* m_FilenameList);

		// Do a block of work, and let the ProgressDialog know how much of
		// the work has been completed so far, and whether the work has
		// been finished or not.
		virtual vgui::TJobStatus DoWork(vgui::JobController* pJobController,
									    int* pPercentComplete);

		// The user has clicked the "Cancel" button, so the worker object
		// should perform any shutdown necessary before returning.  The
		// object will not be called by the ProgressDialog at all after
		// this function has been called.
		virtual void OnCancel(vgui::JobController* pJobController);

	private:
		vgui::TJobStatus DoFileChecks(vgui::JobController* pJobController,
									  int* pPercentComplete);

	private:
		// Info needed to direct work
		FilenameList* m_pFilenameList;

		// Status of work
		uint m_cFiles;
		uint m_iCurrentFile;
		
		// Sorted IDs of new filenames
		std::vector<int> m_SortedIDs;
};

#endif // !inc_FilenameValidateWorker_h
