//
// FilterFilesWorker.h
//

//
// This software is protected by the GNU General Public License,
// also known as the GPL.
//
// See the file COPYING.txt for details.
//

#ifndef inc_FilterFilesWorker_h
#define inc_FilterFilesWorker_h

#include "vgui\JobWorker.h"
#include "vgui\JobController.h"

class FilenameList;

/**************************************************************************

>	class FilterFilesWorker : public vgui::JobWorker

	Author:		Tim Browse
	Date:		30/4/2002

	Purpose:	Do the work of renaming the files, using an interface that
				is compatible with the vGUI ProgressDialog class.

**************************************************************************/

class FilterFilesWorker : public vgui::JobWorker
{
	public:
		// Constructor
		FilterFilesWorker(FilenameList* pFilenameList);

		// JobWorker interface
		virtual vgui::TJobStatus DoWork(vgui::JobController* pJobController,
												   int* pPercentComplete);
		virtual void OnCancel(vgui::JobController* pJobController);

		// Find out if we completed ok
		bool CompletedOK() { return m_bFinished; }

	private:
		// Object controlling the filtering
		FilenameList* m_pFilenameList;

		// Details of file count/progress
		uint m_cFiles;
		uint m_iCurrentFile;

		// Have we finished?
		bool m_bFinished;
};

#endif // !inc_FilterFilesWorker_h
