//
// GenerateFilenamesWorker.h
//

//
// This software is protected by the GNU General Public License,
// also known as the GPL.
//
// See the file COPYING.txt for details.
//

#ifndef inc_GenerateFilenamesWorker_h
#define inc_GenerateFilenamesWorker_h

#include "vgui\JobWorker.h"
#include "vgui\JobController.h"

class FilenameList;

#include "FilenameTransformer.h"

/**************************************************************************

>	class GenerateFilenamesWorker : public vgui::JobWorker

	Author:		Tim Browse
	Date:		30/4/2002

	Purpose:	Do the work of generating the new names for the files to
				be renamed.

**************************************************************************/

class GenerateFilenamesWorker : public vgui::JobWorker
{
	public:
		// Constructor
		GenerateFilenamesWorker(FilenameList* pFilenameList);

		// JobWorker interface
		virtual vgui::TJobStatus DoWork(vgui::JobController* pJobController,
												   int* pPercentComplete);
		virtual void OnCancel(vgui::JobController* pJobController);

		// Find out if we completed ok
		bool CompletedOK() { return m_bFinished; }

	private:
		// Object controlling the filtering
		FilenameList* m_pFilenameList;

		// Object that generates new names
		FilenameTransformer m_Transformer;

		// Details of file count/progress
		uint m_cFiles;
		uint m_iCurrentFile;

		// Have we finished?
		bool m_bFinished;
};

#endif // !inc_GenerateFilenamesWorker_h
