//
// MP3TagReader.h
//

//
// This software is protected by the GNU General Public License,
// also known as the GPL.
//
// See the file COPYING.txt for details.
//

#ifndef inc_MP3TagReader_h
#define inc_MP3TagReader_h

#include "vos\FileSpec.h"

#include "id3\tag.h"

/**************************************************************************

>	class MP3TagReader

	Author:		Tim Browse
	Date:		28/4/2002

	Purpose:	Provide simplified API onto the id3lib API, tailored
				to reading basic track information from a file with
				ID3 tags.

**************************************************************************/

class MP3TagReader
{
	public:
		MP3TagReader(const vos::FileSpec fsMP3File);

		bool GetInfo(vos::String* pArtist, 
					 vos::String* pAlbum, 
					 vos::String* pTrackName, 
					 vos::String* pTrackNumber);

	private:
		bool ReadTextField(ID3_FrameID Frame, vos::String* pText);
		bool ReadIntegerField(ID3_FrameID Frame, uint* pInteger);

	private:
		// The object that does the tag reading (using id3lib)
		ID3_Tag m_Tag;
		
		// Did we get mp3 tags ok?
		bool m_bGoodTags;

};

#endif // !inc_MP3TagReader_h
