//
// ScanFilesWorker.h
//

//
// This software is protected by the GNU General Public License,
// also known as the GPL.
//
// See the file COPYING.txt for details.
//

#ifndef inc_ScanFilesWorker_h
#define inc_ScanFilesWorker_h

#include "vgui\JobWorker.h"
#include "vgui\JobController.h"

#include "vos\FileMatches.h"

#include "FilenameList.h"

/**************************************************************************

>	class ScanFilesWorker : public vgui::JobWorker

	Author:		Tim Browse
	Date:		30/4/2002

	Purpose:	Do the work of renaming the files, using an interface that
				is compatible with the vGUI ProgressDialog class.

**************************************************************************/

class ScanFilesWorker : public vgui::JobWorker
{
	public:
		// Constructor
		ScanFilesWorker(const vos::FileSpec& fsFolderToScan,
						FileSpecs* pFileSpecs);

		// JobWorker interface
		virtual vgui::TJobStatus DoWork(vgui::JobController* pJobController,
										int* pPercentComplete);
		virtual void OnCancel(vgui::JobController* pJobController);

		// Find out if we completed ok
		bool CompletedOK() { return m_bFinished; }

	private:
		void PrepareToScan();

	private:
		// Folder to scan
		vos::FileSpec m_fsFolderToScan;

		// Where to store details of the scanned files
		FileSpecs* m_pFileSpecs;

		// Object used to scan the folder
		vos::FileMatches m_MatchingFiles;

		// Scan started
		bool m_bReadyToScan;

		// Have we finished?
		bool m_bFinished;

		// Does folder even exist?
		bool m_bFolderExists;
};

#endif // !inc_ScanFilesWorker_h
